## mcelog 0.3

=== Makefile ===
CFLAGS := -g -Wall
prefix := /usr

all: mcelog

.PHONY: install clean

INCLUDES := mcelog.h k8.h

mcelog: k8.o mcelog.o

k8.o: k8.c ${INCLUDES}
mcelog.o: mcelog.c ${INCLUDES}

install: mcelog.c
	cp mcelog ${prefix}/sbin/mcelog
	cp mcelog.8 ${prefix}/share/man/man8
	echo "call mcelog regularly from your crontab"

clean:
	rm -f mcelog mcelog.o k8.o

## mcelog 0.4

=== Makefile ===
--- 
+++ 
@@ -7,8 +7,9 @@
 
 INCLUDES := mcelog.h k8.h
 
-mcelog: k8.o mcelog.o
+mcelog: p4.o k8.o mcelog.o
 
+p4.o: p4.c ${INCLUDES}
 k8.o: k8.c ${INCLUDES}
 mcelog.o: mcelog.c ${INCLUDES}
 
@@ -18,4 +19,4 @@
 	echo "call mcelog regularly from your crontab"
 
 clean:
-	rm -f mcelog mcelog.o k8.o
+	rm -f mcelog mcelog.o k8.o p4.o

## mcelog 0.7

=== Makefile ===
CFLAGS := -g -Wall
prefix := /usr

all: mcelog

.PHONY: install clean

mcelog: p4.o k8.o mcelog.o dmi.o

p4.o: p4.c mcelog.h p4.h
k8.o: k8.c mcelog.h k8.h
mcelog.o: mcelog.c mcelog.h dmi.h p4.h k8.h

install: mcelog.c
	cp mcelog ${prefix}/sbin/mcelog
	cp mcelog.8 ${prefix}/share/man/man8
	echo
	echo "call mcelog regularly from your crontab"

clean:
	rm -f mcelog mcelog.o k8.o p4.o dmi.o dmi

dmi:	dmi.c
	gcc -o dmi ${CFLAGS} -DSTANDALONE dmi.c ${LDFLAGS}

## mcelog 0.8~pre

=== Makefile ===
CFLAGS := -g -Wall
prefix := /usr
# Define appropiately for your distribution
# DOCDIR := /usr/share/doc/packages/mcelog

all: mcelog dbquery

.PHONY: install clean depend

OBJ := p4.o k8.o mcelog.o dmi.o db.o dimm.o tsc.o core2.o
SRC := $(OBJ:.o=.c)
CLEAN := mcelog dmi tsc dbquery .depend .depend.X dbquery.o
DOC := mce.pdf smbios.spec

mcelog: ${OBJ}

# dbquery intentionally not installed by default
install: mcelog
	cp mcelog ${prefix}/sbin/mcelog
	cp mcelog.8 ${prefix}/share/man/man8
ifdef DOCDIR
	cp ${DOC} ${DOCDIR} 
else
	echo
	echo "Consider defining DOCDIR to install additional documentation"
endif
	echo
	echo "call mcelog regularly from your crontab"

clean:
	rm -f ${CLEAN} ${OBJ} 

tsc:    tsc.c
	gcc -o tsc ${CFLAGS} -DSTANDALONE tsc.c ${LDFLAGS}

dbquery: db.o dbquery.o

depend: .depend

.depend:
	${CC} -MM -I. ${SRC} > .depend.X && mv .depend.X .depend

include .depend

Makefile: .depend

## mcelog 0.9~pre+1git543dbb

=== Makefile ===
CFLAGS := -g
prefix := /usr
etcprefix :=
# Define appropiately for your distribution
# DOCDIR := /usr/share/doc/packages/mcelog

# Warning flags added implicitely to CFLAGS in the default rule
# this is done so that even when CFLAGS are overriden we still get
# the additional warnings
# Some warnings require the global optimizer and are only output with 
# -O2/-Os, so that should be tested occasionally
WARNINGS := -Wall -Wextra -Wno-missing-field-initializers -Wno-unused-parameter \
	    -Wstrict-prototypes -Wformat-security -Wmissing-declarations \
	    -Wdeclaration-after-statement

# The on disk database has still many problems (partly in this code and partly
# due to missing support from BIOS), so it's disabled by default. You can 
# enable it here by uncommenting the following line
# CONFIG_DISKDB = 1

all: mcelog

.PHONY: install clean depend

OBJ := p4.o k8.o mcelog.o dmi.o tsc.o core2.o bitfield.o intel.o \
       nehalem.o dunnington.o tulsa.o config.o memutil.o msg.o
DISKDB_OBJ := diskdb.o dimm.o db.o
CLEAN := mcelog dmi tsc dbquery .depend .depend.X dbquery.o ${DISKDB_OBJ}
DOC := mce.pdf smbios.spec

ADD_DEFINES :=

ifdef CONFIG_DISKDB
ADD_DEFINES := -DCONFIG_DISKDB=1
OBJ += ${DISKDB_OBJ}

all: dbquery
endif

SRC := $(OBJ:.o=.c)

mcelog: ${OBJ}

# dbquery intentionally not installed by default
install: mcelog
	install -m 755 -p mcelog ${prefix}/sbin/mcelog
	install -m 644 -p mcelog.8 ${prefix}/share/man/man8
	install -m 644 -p -b mcelog.conf ${etcprefix}/etc/mcelog.conf
ifdef DOCDIR
	install -m 644 -p ${DOC} ${DOCDIR} 
else
	echo
	echo "Consider defining DOCDIR to install additional documentation"
endif
	echo
	echo "call mcelog regularly from your crontab"

clean:
	rm -f ${CLEAN} ${OBJ} 

tsc:    tsc.c
	gcc -o tsc ${CFLAGS} -DSTANDALONE tsc.c ${LDFLAGS}

dbquery: db.o dbquery.o memutil.o

depend: .depend

%.o: %.c
	$(CC) -c $(CFLAGS) $(CPPFLAGS) $(WARNINGS) $(ADD_DEFINES) -o $@ $<

.depend: ${SRC}
	${CC} -MM -I. ${SRC} > .depend.X && mv .depend.X .depend

include .depend

Makefile: .depend

.PHONY: iccverify src

# run the icc static verifier over sources. you need the intel compiler installed for this
DISABLED_DIAGS := -diag-disable 188,271,869,2259,981,12072,181,12331,1572

iccverify:
	icc -Wall -diag-enable sv3 $(DISABLED_DIAGS) $(ADD_DEFINES) $(SRC)	

src:
	echo $(SRC)

## mcelog 1.0~pre3

=== debian/changelog ===
mcelog (1.0~pre3-2) unstable; urgency=low

  * debian/copyright:
    + Update.

  * debian/patches/fix_dmi_segfault.patch:
    + Added; fix segfault when SMBIOS tables cannot be mmaped (closes: #585853).

 -- Julien BLACHE <jblache@debian.org>  Tue, 22 Jun 2010 18:45:02 +0200

mcelog (1.0~pre3-1) unstable; urgency=low

  * New upstream release.

  * Package converted to source format 3.0 (quilt).
    + Patches now have DEP-3 headers.

  * debian/rules:
    + Remove dpatch code.
  * debian/control:
    + Remove dpatch from Build-Depends.
    + Bump Standards-Version to 3.8.4 (no changes).
  * debian/mcelog.init:
    + Add $remote_fs to Required-{Start,Stop}.

  * debian/patches/01_64bit_mem_addr.dpatch:
    + Renamed to fix_64bit_mem_addr.patch, refreshed, content unchanged.
  * debian/patches/10_trigger_typo.dpatch:
    + Renamed to fix_trigger_typo.patch, refreshed, content unchanged.

 -- Julien BLACHE <jblache@debian.org>  Tue, 09 Mar 2010 19:39:16 +0100

mcelog (1.0~pre1-1) unstable; urgency=low

  * New upstream release (closes: #561163).
    + Disk DB for memory errors is deprecated upstream and disabled.

  * debian/mcelog.init:
    + Add support for daemon mode, keep support for trigger mode.
  * debian/mcelog.default:
    + Added; default to daemon mode for mcelog.
  * debian/mcelog.postinst:
    + Remove code handling /var/lib/memory-errors on upgrade from
      versions < 0.8~pre-5 (0.8~pre-8 in Lenny).
  * debian/mcelog.preinst:
    + Move /etc/mcelog.conf to /etc/mcelog/mcelog.conf.
  * debian/mcelog.NEWS, debian/README.Debian:
    + Updated.
  * debian/rules:
    + Restart mcelog on upgrade (remove -r from dh_installinit).

  * debian/patches/03_memory_errors.dpatch:
    + Removed; no longer needed as disk DB is now disabled.
  * debian/patches/10_trigger_typo.dpatch:
    + Added; fix a small typo in cache-error-trigger.

 -- Julien BLACHE <jblache@debian.org>  Fri, 18 Dec 2009 19:06:09 +0100

mcelog (0.9~pre+2gitb7ddf8-2) unstable; urgency=low

  * debian/mcelog.init:
    + Check for existence of $TRIGGER in all actions (closes: #553200).

 -- Julien BLACHE <jblache@debian.org>  Thu, 29 Oct 2009 17:51:05 +0100

mcelog (0.9~pre+2gitb7ddf8-1) unstable; urgency=low

  * New git snapshot, b7ddf8dbc7ad289f8e316e730b7f6d0f97720a82.
    + Several fixes, including Nehalem channel decoding.

 -- Julien BLACHE <jblache@debian.org>  Sun, 11 Oct 2009 11:23:14 +0200

mcelog (0.9~pre+1git543dbb-2) unstable; urgency=low

  * debian/control:
    + Swap udev and makedev in the alternative (closes: #546875).
    + Bump Standards-Version to 3.8.3 (no changes).

 -- Julien BLACHE <jblache@debian.org>  Wed, 16 Sep 2009 18:58:09 +0200

mcelog (0.9~pre+1git543dbb-1) unstable; urgency=low

  * Snapshot from git (543dbb) (closes: #538163).

  * Makefile:
    + Enable disk db (was always enabled in previous versions).

  * debian/copyright:
    + Mention upstream git tree location.
  * debian/rules:
    + Pass etcprefix at install time.
  * debian/dirs:
    + Add etc for conffile installation.

  * debian/patches/01_64bit_mem_addr.dpatch:
    + Updated.
  * debian/patches/02_tsc_secs_fix.dpatch:
    + Removed; fixed upstream.
  * debian/patches/03_memory_errors.dpatch:
    + Updated.

 -- Julien BLACHE <jblache@debian.org>  Fri, 24 Jul 2009 09:02:07 +0200

mcelog (0.9~pre1-3) unstable; urgency=low

  * Reupload to unstable.

 -- Julien BLACHE <jblache@debian.org>  Thu, 09 Jul 2009 13:27:33 +0200

mcelog (0.9~pre1-2) experimental; urgency=low

  * Switch to running mcelog via the kernel MCE trigger instead of running
    via cron (closes: #535180).

  * debian/README.Debian:
    + Updated for trigger mode.
  * debian/mcelog.NEWS:
    + Document switch to trigger mode.
  * debian/control:
    + Remove po-debconf build-dep.
    + Add fixed dependencies on debconf for purging the templates.
    + Fix description, MCE will now be logged to syslog.
  * debian/rules:
    + Do not install logrotate config snippet.
    + Do not install cron config snippet.
    + Do not install debconf scripts.
    + Install mcelog init script.
  * debian/mcelog.postinst:
    + Remove debconf code and stop checking for /dev/mcelog usability.
  * debian/mcelog.postrm:
    + Purge debconf templates on purge (manually).
  * debian/mcelog.preinst:
    + Remove obsolete conffiles: /etc/logrotate.d/mcelog, /etc/cron.d/mcelog,
      /etc/mcelog-disabled.
  * debian/mcelog.init:
    + Added; simple init script to set up the kernel trigger.

  * debian/patches/10_debian_test.dpatch, debian/patches/11_logrotate.dpatch,
    debian/mcelog.cron.d, debian/mcelog.templates, debian/po/*:
    + Removed.

 -- Julien BLACHE <jblache@debian.org>  Thu, 02 Jul 2009 18:41:32 +0200

mcelog (0.9~pre1-1) unstable; urgency=low

  * New upstream (pre) release.

  * debian/control:
    + Bump Standards-Version to 3.8.2 (no changes).
    + Remove supported processors from the description; the list is
      growing and is pointless now.
  * debian/copyright:
    + Updated.

  * debian/patches/03_memory_errors.dpatch:
    + Updated.
  * debian/patches/10_debian_test.dpatch:
    + Updated.

 -- Julien BLACHE <jblache@debian.org>  Tue, 30 Jun 2009 19:19:29 +0200

mcelog (0.8~pre-8) unstable; urgency=low

  * debian/mcelog.postrm:
    + Check for /var/lib/mcelog existence, in case it's been removed by dpkg
      before postrm is run (closes: #507349).

 -- Julien BLACHE <jblache@debian.org>  Sun, 30 Nov 2008 13:38:11 +0100

mcelog (0.8~pre-7) unstable; urgency=low

  * debian/control:
    + Fix typo in description (closes: #505441).

  * debian/mcelog.postinst, debian/mcelog.postrm:
    + Make postinst and postrm scripts set -e.

 -- Julien BLACHE <jblache@debian.org>  Wed, 12 Nov 2008 13:43:07 +0100

mcelog (0.8~pre-6) unstable; urgency=low

  * debian/control:
    + Bump Standards-Version to 3.8.0 (no changes).

  * debconf translations:
    + sv.po: courtesy of Martin Ågren (closes: #492064).



=== debian/control ===
Source: mcelog
Section: admin
Priority: optional
Maintainer: Julien BLACHE <jblache@debian.org>
Build-Depends: debhelper (>= 5.0.0)
Standards-Version: 3.8.4

Package: mcelog
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, debconf (>= 0.5) | debconf-2.0, udev | makedev (>= 2.3.1-81)
Description: x86-64 Machine Check Exceptions collector and decoder
 Starting with version 2.6.4, the Linux kernel for x86-64 no longer decodes
 and logs recoverable Machine Check Exception events to the kernel log on
 its own.
 .
 Instead, the MCE data is kept in a buffer which can be read from userspace
 via the /dev/mcelog device node.
 .
 You need this tool to collect and decode those events; it will log the decoded
 MCE events to syslog.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.

	touch configure-stamp


build: build-stamp
build-stamp: configure-stamp 
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE) CFLAGS="$(CFLAGS)"

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	# Add here commands to clean up after the build process.
	$(MAKE) clean

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

	# Add here commands to install the package into debian/mcelog.
	mkdir -p $(CURDIR)/debian/mcelog/usr/share/doc/mcelog
	$(MAKE) install prefix=$(CURDIR)/debian/mcelog/usr \
		etcprefix=$(CURDIR)/debian/mcelog \
		DOCDIR=$(CURDIR)/debian/mcelog/usr/share/doc/mcelog

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs CHANGES
	dh_installdocs
#	dh_install
	dh_installinit -- start 20 2 3 4 5 .
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## mcelog 1.0~pre3-66-g39f5b74

=== debian/changelog ===
mcelog (1.0~pre3-66-g39f5b74-1) unstable; urgency=low

  * New git snapshot.
  * Removed sourceless PDF files.

  * debian/control:
    + Bump Standards-Version to 3.9.2 (no changes).
  * debian/rules:
    + Do not define DOCDIR at install time, PDFs have been removed so there
      is no additional documentation to install anymore.

  * debian/patches/fix_timeout_bit.patch,
    debian/patches/fix_trigger_typo.dpatch:
    + Removed; merged upstream.

 -- Julien BLACHE <jblache@debian.org>  Fri, 03 Jun 2011 19:04:47 +0200

mcelog (1.0~pre3-3) unstable; urgency=low

  * debian/patches/fix_timeout_bit.patch:
    + Added; fix interpretation of the timeout bit (closes: #587365).

 -- Julien BLACHE <jblache@debian.org>  Mon, 28 Jun 2010 18:15:24 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Julien BLACHE <jblache@debian.org>
 Build-Depends: debhelper (>= 5.0.0)
-Standards-Version: 3.8.4
+Standards-Version: 3.9.2
 
 Package: mcelog
 Architecture: i386 amd64

=== debian/rules ===
--- 
+++ 
@@ -53,8 +53,7 @@
 	# Add here commands to install the package into debian/mcelog.
 	mkdir -p $(CURDIR)/debian/mcelog/usr/share/doc/mcelog
 	$(MAKE) install prefix=$(CURDIR)/debian/mcelog/usr \
-		etcprefix=$(CURDIR)/debian/mcelog \
-		DOCDIR=$(CURDIR)/debian/mcelog/usr/share/doc/mcelog
+		etcprefix=$(CURDIR)/debian/mcelog
 
 # Build architecture-independent files here.
 binary-indep: build install

## mcelog 1.0~pre3-72

=== Makefile ===
--- 
+++ 
@@ -1,8 +1,11 @@
-CFLAGS := -g
+CFLAGS := -g -Os
 prefix := /usr
 etcprefix :=
 # Define appropiately for your distribution
 # DOCDIR := /usr/share/doc/packages/mcelog
+
+# Note when changing prefix: some of the non-critical files like
+# the manpage or the init script have hardcoded prefixes
 
 # Warning flags added implicitely to CFLAGS in the default rule
 # this is done so that even when CFLAGS are overriden we still get
@@ -18,15 +21,21 @@
 # enable it here by uncommenting the following line
 # CONFIG_DISKDB = 1
 
+TRIGGERS=cache-error-trigger dimm-error-trigger page-error-trigger \
+	 socket-memory-error-trigger
+
 all: mcelog
 
 .PHONY: install clean depend
 
 OBJ := p4.o k8.o mcelog.o dmi.o tsc.o core2.o bitfield.o intel.o \
-       nehalem.o dunnington.o tulsa.o config.o memutil.o msg.o
+       nehalem.o dunnington.o tulsa.o config.o memutil.o msg.o   \
+       eventloop.o leaky-bucket.o memdb.o server.o trigger.o 	 \
+       client.o cache.o sysfs.o yellow.o page.o rbtree.o 	 \
+       xeon75xx.o sandy-bridge.o
 DISKDB_OBJ := diskdb.o dimm.o db.o
 CLEAN := mcelog dmi tsc dbquery .depend .depend.X dbquery.o ${DISKDB_OBJ}
-DOC := mce.pdf smbios.spec
+DOC := mce.pdf
 
 ADD_DEFINES :=
 
@@ -43,19 +52,21 @@
 
 # dbquery intentionally not installed by default
 install: mcelog
+	mkdir -p ${etcprefix}/etc/mcelog ${prefix}/sbin ${prefix}/share/man/man8
 	install -m 755 -p mcelog ${prefix}/sbin/mcelog
 	install -m 644 -p mcelog.8 ${prefix}/share/man/man8
-	install -m 644 -p -b mcelog.conf ${etcprefix}/etc/mcelog.conf
+	install -m 644 -p -b mcelog.conf ${etcprefix}/etc/mcelog/mcelog.conf
+	for i in ${TRIGGERS} ; do 						\
+		install -m 755 -p -b triggers/$$i ${etcprefix}/etc/mcelog ; 	\
+	done
 ifdef DOCDIR
 	install -m 644 -p ${DOC} ${DOCDIR} 
 else
 	echo
 	echo "Consider defining DOCDIR to install additional documentation"
 endif
-	echo
-	echo "call mcelog regularly from your crontab"
 
-clean:
+clean: test-clean
 	rm -f ${CLEAN} ${OBJ} 
 
 tsc:    tsc.c
@@ -75,7 +86,7 @@
 
 Makefile: .depend
 
-.PHONY: iccverify src
+.PHONY: iccverify src test
 
 # run the icc static verifier over sources. you need the intel compiler installed for this
 DISABLED_DIAGS := -diag-disable 188,271,869,2259,981,12072,181,12331,1572
@@ -83,5 +94,23 @@
 iccverify:
 	icc -Wall -diag-enable sv3 $(DISABLED_DIAGS) $(ADD_DEFINES) $(SRC)	
 
+clangverify:
+	clang --analyze $(ADD_DEFINES) $(SRC)
+
 src:
 	echo $(SRC)
+
+config-test: config.c
+	gcc -DTEST=1 config.c -o config-test
+
+test:
+	$(MAKE) -C tests test DEBUG=""
+
+VALGRIND=valgrind --leak-check=full
+
+valgrind-test:
+	$(MAKE) -C tests test DEBUG="${VALGRIND}"
+
+test-clean:
+	$(MAKE) -C tests clean
+

=== tests/Makefile ===
.PHONY: test clean

DEBUG =

test:
	./test cache "${DEBUG}"
	./test page "${DEBUG}"
	./test memdb "${DEBUG}"
	./test socket "${DEBUG}"
	./test pfa "${DEBUG}"

clean:
	rm -f */*log
	rm -f */results

## mcelog 1.0~pre3-72-gcbd4da4

=== debian/changelog ===
mcelog (1.0~pre3-72-gcbd4da4-1) unstable; urgency=low

  * New git snapshot.

  * debian/control:
    + Rework package description; mcelog is now required on i386 kernels too,
      since the x86 and x86-64 MCE support got merged together after the big
      x86 merge (closes: #629408).

 -- Julien BLACHE <jblache@debian.org>  Wed, 20 Jul 2011 18:41:03 +0200

=== debian/control ===
Source: mcelog
Section: admin
Priority: optional
Maintainer: Julien BLACHE <jblache@debian.org>
Build-Depends: debhelper (>= 5.0.0)
Standards-Version: 3.9.2

Package: mcelog
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, debconf (>= 0.5) | debconf-2.0, udev | makedev (>= 2.3.1-81)
Description: x86 Machine Check Exceptions collector and decoder
 The Linux kernel for x86 CPUs no longer decodes and logs recoverable
 Machine Check Exception (MCE) events to the kernel log on its own.
 .
 Instead, the MCE data is kept in a buffer which can be read from userspace
 via the /dev/mcelog device node.
 .
 You need this tool to collect and decode those events; it will log the decoded
 MCE events to syslog.

## mcelog 100

=== Makefile ===
--- 
+++ 
@@ -32,7 +32,7 @@
        nehalem.o dunnington.o tulsa.o config.o memutil.o msg.o   \
        eventloop.o leaky-bucket.o memdb.o server.o trigger.o 	 \
        client.o cache.o sysfs.o yellow.o page.o rbtree.o 	 \
-       xeon75xx.o sandy-bridge.o
+       xeon75xx.o sandy-bridge.o ivy-bridge.o msr.o
 DISKDB_OBJ := diskdb.o dimm.o db.o
 CLEAN := mcelog dmi tsc dbquery .depend .depend.X dbquery.o ${DISKDB_OBJ}
 DOC := mce.pdf
@@ -52,15 +52,15 @@
 
 # dbquery intentionally not installed by default
 install: mcelog
-	mkdir -p ${etcprefix}/etc/mcelog ${prefix}/sbin ${prefix}/share/man/man8
-	install -m 755 -p mcelog ${prefix}/sbin/mcelog
-	install -m 644 -p mcelog.8 ${prefix}/share/man/man8
-	install -m 644 -p -b mcelog.conf ${etcprefix}/etc/mcelog/mcelog.conf
+	mkdir -p $(DESTDIR)${etcprefix}/etc/mcelog $(DESTDIR)${prefix}/sbin $(DESTDIR)${prefix}/share/man/man8
+	install -m 755 -p mcelog $(DESTDIR)${prefix}/sbin/mcelog
+	install -m 644 -p mcelog.8 $(DESTDIR)${prefix}/share/man/man8
+	install -m 644 -p -b mcelog.conf $(DESTDIR)${etcprefix}/etc/mcelog/mcelog.conf
 	for i in ${TRIGGERS} ; do 						\
-		install -m 755 -p -b triggers/$$i ${etcprefix}/etc/mcelog ; 	\
+		install -m 755 -p -b triggers/$$i $(DESTDIR)${etcprefix}/etc/mcelog ; 	\
 	done
 ifdef DOCDIR
-	install -m 644 -p ${DOC} ${DOCDIR} 
+	install -m 644 -p ${DOC} $(DESTDIR)${DOCDIR} 
 else
 	echo
 	echo "Consider defining DOCDIR to install additional documentation"

=== debian/changelog ===
mcelog (100-1fakesync1) trusty-proposed; urgency=medium

  * Fake sync due to mismatching orig tarball.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 21 Feb 2014 17:40:03 -0800

mcelog (100-1) unstable; urgency=medium

  * New upstream snapshot
  * Upload to unstable
  * Source /lib/lsb/init-functions in the init script
  * Use canonical URLs in Vcs-*
  * Bump Standards-Version to 3.9.5 (no change needed)

 -- Andrey Rahmatullin <wrar@wrar.name>  Thu, 13 Feb 2014 02:39:38 +0600

mcelog (1.0~snapshot20121127-1~exp1) experimental; urgency=low

  * New upstream snapshot
    + Don't call all unsupported systems "new" (Closes: #676573)
  * Upload to experimental
  * Adopt the package (Closes: #688540)
  * Switch to debhelper v9 and to dh(1)
  * Rewrite debian/copyright in the machine-readable format, mention the
    license of rbtree.*
  * Add the Homepage field
  * Add the Vcs-* fields
  * Bump Standards-Version to 3.9.4 (no change needed)
  * Fix a spelling error
  * Escape hyphens in the manpage
  * Add proper Default-Stop: to the initscript

 -- Andrey Rahmatullin <wrar@wrar.name>  Fri, 30 Nov 2012 23:14:24 +0600

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,13 @@
 Source: mcelog
 Section: admin
 Priority: optional
-Maintainer: Julien BLACHE <jblache@debian.org>
-Build-Depends: debhelper (>= 5.0.0)
-Standards-Version: 3.9.2
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Andrey Rahmatullin <wrar@wrar.name>
+Build-Depends: debhelper (>= 9)
+Standards-Version: 3.9.5
+Homepage: http://mcelog.org/
+Vcs-Git: git://anonscm.debian.org/collab-maint/mcelog.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/mcelog.git;a=summary
 
 Package: mcelog
 Architecture: i386 amd64

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_test:

.PHONY: override_dh_auto_test

## mcelog 104

=== Makefile ===
--- 
+++ 
@@ -22,7 +22,10 @@
 # CONFIG_DISKDB = 1
 
 TRIGGERS=cache-error-trigger dimm-error-trigger page-error-trigger \
-	 socket-memory-error-trigger
+	 socket-memory-error-trigger \
+	 bus-error-trigger \
+	 iomca-error-trigger \
+	 unknown-error-trigger
 
 all: mcelog
 
@@ -32,7 +35,7 @@
        nehalem.o dunnington.o tulsa.o config.o memutil.o msg.o   \
        eventloop.o leaky-bucket.o memdb.o server.o trigger.o 	 \
        client.o cache.o sysfs.o yellow.o page.o rbtree.o 	 \
-       xeon75xx.o sandy-bridge.o ivy-bridge.o msr.o
+       xeon75xx.o sandy-bridge.o ivy-bridge.o haswell.o msr.o bus.o unknown.o
 DISKDB_OBJ := diskdb.o dimm.o db.o
 CLEAN := mcelog dmi tsc dbquery .depend .depend.X dbquery.o ${DISKDB_OBJ}
 DOC := mce.pdf

=== debian/changelog ===
mcelog (104-1) unstable; urgency=medium

  * New upstream version
  * Drop MAKEDEV invocation from postinst and the alternative dependency on it.
  * Add --is-cpu-supported option and use it in the initscript to not fail on
    unsupported hardware (Closes: #738927)
  * Bump Standards-Version to 3.9.6 (no change needed)

 -- Andrey Rahmatullin <wrar@debian.org>  Mon, 20 Oct 2014 22:54:26 +0600

mcelog (102-1) unstable; urgency=medium

  * New upstream version
    - don't exit on AMD Family 15 CPUs
  * Note in the package description which CPUs are supported
  * Use CFLAGS from dpkg-buildflags

 -- Andrey Rahmatullin <wrar@debian.org>  Sun, 10 Aug 2014 23:45:42 +0600

=== debian/control ===
Source: mcelog
Section: admin
Priority: optional
Maintainer: Andrey Rahmatullin <wrar@debian.org>
Build-Depends: debhelper (>= 9)
Standards-Version: 3.9.6
Homepage: http://mcelog.org/
Vcs-Git: git://anonscm.debian.org/collab-maint/mcelog.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/mcelog.git;a=summary

Package: mcelog
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, debconf (>= 0.5) | debconf-2.0, udev
Description: x86 Machine Check Exceptions collector and decoder
 The Linux kernel for x86 CPUs no longer decodes and logs recoverable
 Machine Check Exception (MCE) events to the kernel log on its own.
 .
 Instead, the MCE data is kept in a buffer which can be read from userspace
 via the /dev/mcelog device node.
 .
 You need this tool to collect and decode those events; it will log the decoded
 MCE events to syslog.
 .
 This tool supports only Intel processors and AMD processors with model number
 16 (K8).

## mcelog 128+dfsg

=== debian/changelog ===
mcelog (128+dfsg-1) unstable; urgency=medium

  * New upstream version (Closes: #792263)
  * Add debian/watch by Dmitry Smirnov
  * Document that some files are removed from the upstream tarball by adding
    Files-Excluded to debian/changelog and adding +dfsg to the version

 -- Andrey Rahmatullin <wrar@debian.org>  Sat, 07 Nov 2015 16:10:07 +0500

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: admin
 Priority: optional
 Maintainer: Andrey Rahmatullin <wrar@debian.org>
-Build-Depends: debhelper (>= 9)
+Build-Depends: debhelper (>= 9), python
 Standards-Version: 3.9.6
 Homepage: http://mcelog.org/
 Vcs-Git: git://anonscm.debian.org/collab-maint/mcelog.git

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_build:
	rm mcelog.conf.5
	dh_auto_build

override_dh_auto_test:

.PHONY: override_dh_auto_test override_dh_auto_build

## mcelog 134+dfsg

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,7 @@
 CFLAGS := -g -Os
 prefix := /usr
 etcprefix :=
+MANDIR := ${prefix}/share/man
 # Define appropiately for your distribution
 # DOCDIR := /usr/share/doc/packages/mcelog
 
@@ -29,15 +30,18 @@
 
 all: mcelog
 
-.PHONY: install clean depend
+.PHONY: install clean depend FORCE
 
 OBJ := p4.o k8.o mcelog.o dmi.o tsc.o core2.o bitfield.o intel.o \
        nehalem.o dunnington.o tulsa.o config.o memutil.o msg.o   \
        eventloop.o leaky-bucket.o memdb.o server.o trigger.o 	 \
        client.o cache.o sysfs.o yellow.o page.o rbtree.o 	 \
-       xeon75xx.o sandy-bridge.o ivy-bridge.o haswell.o msr.o bus.o unknown.o
+       xeon75xx.o sandy-bridge.o ivy-bridge.o haswell.o		 \
+       broadwell_de.o broadwell_epex.o msr.o bus.o \
+       unknown.o
 DISKDB_OBJ := diskdb.o dimm.o db.o
-CLEAN := mcelog dmi tsc dbquery .depend .depend.X dbquery.o ${DISKDB_OBJ}
+CLEAN := mcelog dmi tsc dbquery .depend .depend.X dbquery.o ${DISKDB_OBJ} \
+	version.o version.c version.tmp
 DOC := mce.pdf
 
 ADD_DEFINES :=
@@ -51,29 +55,35 @@
 
 SRC := $(OBJ:.o=.c)
 
-mcelog: ${OBJ}
+mcelog: ${OBJ} version.o
 
 # dbquery intentionally not installed by default
-install: mcelog
-	mkdir -p $(DESTDIR)${etcprefix}/etc/mcelog $(DESTDIR)${prefix}/sbin $(DESTDIR)${prefix}/share/man/man8
+install: mcelog mcelog.conf mcelog.conf.5 mcelog.triggers.5
+	mkdir -p $(DESTDIR)${etcprefix}/etc/mcelog $(DESTDIR)${prefix}/sbin $(DESTDIR)$(MANDIR)/man5 $(DESTDIR)$(MANDIR)/man8
 	install -m 755 -p mcelog $(DESTDIR)${prefix}/sbin/mcelog
-	install -m 644 -p mcelog.8 $(DESTDIR)${prefix}/share/man/man8
+	install -m 644 -p mcelog.8 $(DESTDIR)$(MANDIR)/man8
+	install -m 644 -p mcelog.conf.5 $(DESTDIR)$(MANDIR)/man5
+	install -m 644 -p mcelog.triggers.5 $(DESTDIR)$(MANDIR)/man5
 	install -m 644 -p -b mcelog.conf $(DESTDIR)${etcprefix}/etc/mcelog/mcelog.conf
 	for i in ${TRIGGERS} ; do 						\
 		install -m 755 -p -b triggers/$$i $(DESTDIR)${etcprefix}/etc/mcelog ; 	\
 	done
 ifdef DOCDIR
+	install -d 755 $(DESTDIR)${DOCDIR} 
 	install -m 644 -p ${DOC} $(DESTDIR)${DOCDIR} 
 else
 	echo
 	echo "Consider defining DOCDIR to install additional documentation"
 endif
 
+mcelog.conf.5: mcelog.conf config-intro.man
+	./genconfig.py mcelog.conf config-intro.man > mcelog.conf.5
+
 clean: test-clean
 	rm -f ${CLEAN} ${OBJ} 
 
 tsc:    tsc.c
-	gcc -o tsc ${CFLAGS} -DSTANDALONE tsc.c ${LDFLAGS}
+	$(CC) -o tsc ${CFLAGS} -DSTANDALONE tsc.c ${LDFLAGS}
 
 dbquery: db.o dbquery.o memutil.o
 
@@ -81,6 +91,21 @@
 
 %.o: %.c
 	$(CC) -c $(CFLAGS) $(CPPFLAGS) $(WARNINGS) $(ADD_DEFINES) -o $@ $<
+
+version.tmp: FORCE
+	( echo -n "char version[] = \"" ; 	\
+	if type -p git >/dev/null; then 	\
+	if [ -d .git ] ; then 			\
+		git describe --tags HEAD | tr -d '\n'; 	\
+	else 					\
+		echo -n "unknown" ; 		\
+	fi ;					\
+	else echo -n "unknown" ; fi ;		\
+	echo '";'				\
+	 ) > version.tmp
+
+version.c: version.tmp
+	cmp version.tmp version.c || mv version.tmp version.c
 
 .depend: ${SRC}
 	${CC} -MM -I. ${SRC} > .depend.X && mv .depend.X .depend
@@ -104,7 +129,7 @@
 	echo $(SRC)
 
 config-test: config.c
-	gcc -DTEST=1 config.c -o config-test
+	$(CC) -DTEST=1 config.c -o config-test
 
 test:
 	$(MAKE) -C tests test DEBUG=""

=== debian/changelog ===
mcelog (134+dfsg-1) unstable; urgency=medium

  * New upstream version
    + use /sys/firmware/dmi instead of /dev/mem if available, fix handling
      /dev/mem fd (Closes: #816825)
  * Bump Standards-Version to 3.9.7 (no change needed)
  * Update Vcs-* fields to use HTTPS
  * Fix spelling errors in code and manpages

 -- Andrey Rahmatullin <wrar@debian.org>  Sun, 27 Mar 2016 13:49:32 +0500

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,10 @@
 Priority: optional
 Maintainer: Andrey Rahmatullin <wrar@debian.org>
 Build-Depends: debhelper (>= 9), python
-Standards-Version: 3.9.6
+Standards-Version: 3.9.7
 Homepage: http://mcelog.org/
-Vcs-Git: git://anonscm.debian.org/collab-maint/mcelog.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/mcelog.git;a=summary
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/mcelog.git
+Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/mcelog.git;a=summary
 
 Package: mcelog
 Architecture: i386 amd64

## mcelog 137+dfsg

=== debian/changelog ===
mcelog (137+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Bump Standards-Version to 3.9.8 (no change needed)
  * Drop merged fix-spelling.patch

 -- Andrey Rahmatullin <wrar@debian.org>  Sat, 21 May 2016 21:28:37 +0500

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Andrey Rahmatullin <wrar@debian.org>
 Build-Depends: debhelper (>= 9), python
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Homepage: http://mcelog.org/
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/mcelog.git
 Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/mcelog.git;a=summary

## mcelog 140+dfsg

=== Makefile ===
--- 
+++ 
@@ -37,8 +37,8 @@
        eventloop.o leaky-bucket.o memdb.o server.o trigger.o 	 \
        client.o cache.o sysfs.o yellow.o page.o rbtree.o 	 \
        xeon75xx.o sandy-bridge.o ivy-bridge.o haswell.o		 \
-       broadwell_de.o broadwell_epex.o msr.o bus.o \
-       unknown.o
+       broadwell_de.o broadwell_epex.o skylake_xeon.o		 \
+       msr.o bus.o unknown.o
 DISKDB_OBJ := diskdb.o dimm.o db.o
 CLEAN := mcelog dmi tsc dbquery .depend .depend.X dbquery.o ${DISKDB_OBJ} \
 	version.o version.c version.tmp

=== debian/changelog ===
mcelog (140+dfsg-1) unstable; urgency=medium

  * New upstream version

 -- Andrey Rahmatullin <wrar@debian.org>  Sun, 21 Aug 2016 16:27:29 +0500

=== debian/control ===
--- 
+++ 
@@ -2,6 +2,7 @@
 Section: admin
 Priority: optional
 Maintainer: Andrey Rahmatullin <wrar@debian.org>
+Uploaders: Nicholas D Steeves <nsteeves@gmail.com>
 Build-Depends: debhelper (>= 9), python
 Standards-Version: 3.9.8
 Homepage: http://mcelog.org/

## mcelog 144+dfsg

=== tests/Makefile ===
--- 
+++ 
@@ -11,4 +11,4 @@
 
 clean:
 	rm -f */*log
-	rm -f */results
+	rm -f */results*

=== debian/changelog ===
mcelog (144+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Switch to debhelper compat level 10
  * Add Depends: lsb-base
  * Add x32 to Architecture:

 -- Andrey Rahmatullin <wrar@debian.org>  Thu, 03 Nov 2016 00:26:44 +0500

## mcelog 147+dfsg

=== Makefile ===
--- 
+++ 
@@ -17,11 +17,6 @@
 	    -Wstrict-prototypes -Wformat-security -Wmissing-declarations \
 	    -Wdeclaration-after-statement
 
-# The on disk database has still many problems (partly in this code and partly
-# due to missing support from BIOS), so it's disabled by default. You can 
-# enable it here by uncommenting the following line
-# CONFIG_DISKDB = 1
-
 TRIGGERS=cache-error-trigger dimm-error-trigger page-error-trigger \
 	 socket-memory-error-trigger \
 	 bus-error-trigger \
@@ -36,22 +31,15 @@
        nehalem.o dunnington.o tulsa.o config.o memutil.o msg.o   \
        eventloop.o leaky-bucket.o memdb.o server.o trigger.o 	 \
        client.o cache.o sysfs.o yellow.o page.o rbtree.o 	 \
-       xeon75xx.o sandy-bridge.o ivy-bridge.o haswell.o		 \
+       sandy-bridge.o ivy-bridge.o haswell.o		 	 \
        broadwell_de.o broadwell_epex.o skylake_xeon.o		 \
+       denverton.o						 \
        msr.o bus.o unknown.o
-DISKDB_OBJ := diskdb.o dimm.o db.o
-CLEAN := mcelog dmi tsc dbquery .depend .depend.X dbquery.o ${DISKDB_OBJ} \
+CLEAN := mcelog dmi tsc dbquery .depend .depend.X dbquery.o \
 	version.o version.c version.tmp
 DOC := mce.pdf
 
 ADD_DEFINES :=
-
-ifdef CONFIG_DISKDB
-ADD_DEFINES := -DCONFIG_DISKDB=1
-OBJ += ${DISKDB_OBJ}
-
-all: dbquery
-endif
 
 SRC := $(OBJ:.o=.c)

=== tests/Makefile ===
.PHONY: test clean

DEBUG=

test:
	./test cache "${DEBUG}"
	./test page "${DEBUG}"
	./test memdb "${DEBUG}"
	./test socket "${DEBUG}"
	./test pfa "${DEBUG}"
	./test unknown "${DEBUG}"
	./test server "${DEBUG}"

clean:
	rm -f */*log
	rm -f */results*

=== debian/changelog ===
mcelog (147+dfsg-1) unstable; urgency=medium

  * New upstream version

 -- Andrey Rahmatullin <wrar@debian.org>  Fri, 13 Jan 2017 22:37:05 +0500

=== debian/control ===
--- 
+++ 
@@ -3,15 +3,15 @@
 Priority: optional
 Maintainer: Andrey Rahmatullin <wrar@debian.org>
 Uploaders: Nicholas D Steeves <nsteeves@gmail.com>
-Build-Depends: debhelper (>= 9), python
+Build-Depends: debhelper (>= 10), python
 Standards-Version: 3.9.8
 Homepage: http://mcelog.org/
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/mcelog.git
 Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/mcelog.git;a=summary
 
 Package: mcelog
-Architecture: i386 amd64
-Depends: ${shlibs:Depends}, ${misc:Depends}, debconf (>= 0.5) | debconf-2.0, udev
+Architecture: i386 amd64 x32
+Depends: ${shlibs:Depends}, ${misc:Depends}, debconf (>= 0.5) | debconf-2.0, udev, lsb-base
 Description: x86 Machine Check Exceptions collector and decoder
  The Linux kernel for x86 CPUs no longer decodes and logs recoverable
  Machine Check Exception (MCE) events to the kernel log on its own.

=== debian/watch ===
version=3

opts=dversionmangle=s/\+dfsg\d*$// \
 https://github.com/andikleen/mcelog/releases \
 .*/archive/v?(\d[\d\.]+)\.tar\.gz

## mcelog 153+dfsg

=== Makefile ===
--- 
+++ 
@@ -11,7 +11,7 @@
 # Warning flags added implicitely to CFLAGS in the default rule
 # this is done so that even when CFLAGS are overriden we still get
 # the additional warnings
-# Some warnings require the global optimizer and are only output with 
+# Some warnings require the global optimizer and are only output with
 # -O2/-Os, so that should be tested occasionally
 WARNINGS := -Wall -Wextra -Wno-missing-field-initializers -Wno-unused-parameter \
 	    -Wstrict-prototypes -Wformat-security -Wmissing-declarations \
@@ -57,8 +57,8 @@
 		install -m 755 -p -b triggers/$$i $(DESTDIR)${etcprefix}/etc/mcelog ; 	\
 	done
 ifdef DOCDIR
-	install -d 755 $(DESTDIR)${DOCDIR} 
-	install -m 644 -p ${DOC} $(DESTDIR)${DOCDIR} 
+	install -d 755 $(DESTDIR)${DOCDIR}
+	install -m 644 -p ${DOC} $(DESTDIR)${DOCDIR}
 else
 	echo
 	echo "Consider defining DOCDIR to install additional documentation"
@@ -68,7 +68,7 @@
 	./genconfig.py mcelog.conf config-intro.man > mcelog.conf.5
 
 clean: test-clean
-	rm -f ${CLEAN} ${OBJ} 
+	rm -f ${CLEAN} ${OBJ}
 
 tsc:    tsc.c
 	$(CC) -o tsc ${CFLAGS} -DSTANDALONE tsc.c ${LDFLAGS}
@@ -81,16 +81,20 @@
 	$(CC) -c $(CFLAGS) $(CPPFLAGS) $(WARNINGS) $(ADD_DEFINES) -o $@ $<
 
 version.tmp: FORCE
-	( echo -n "char version[] = \"" ; 	\
-	if type -p git >/dev/null; then 	\
-	if [ -d .git ] ; then 			\
-		git describe --tags HEAD | tr -d '\n'; 	\
-	else 					\
-		echo -n "unknown" ; 		\
-	fi ;					\
-	else echo -n "unknown" ; fi ;		\
-	echo '";'				\
-	 ) > version.tmp
+	( printf "char version[] = \"" ; 			\
+	if test -e .os_version; then				\
+		cat .os_version	| tr -d '\n' ;			\
+	elif command -v git >/dev/null; then 			\
+		if [ -d .git ] ; then 				\
+			git describe --tags HEAD | tr -d '\n'; 	\
+		else 						\
+			printf "unknown" ; 			\
+		fi ;						\
+	else							\
+		printf "unknown" ;				\
+	fi ;							\
+	printf '";\n'						\
+	) > version.tmp
 
 version.c: version.tmp
 	cmp version.tmp version.c || mv version.tmp version.c
@@ -108,7 +112,7 @@
 DISABLED_DIAGS := -diag-disable 188,271,869,2259,981,12072,181,12331,1572
 
 iccverify:
-	icc -Wall -diag-enable sv3 $(DISABLED_DIAGS) $(ADD_DEFINES) $(SRC)	
+	icc -Wall -diag-enable sv3 $(DISABLED_DIAGS) $(ADD_DEFINES) $(SRC)
 
 clangverify:
 	clang --analyze $(ADD_DEFINES) $(SRC)
@@ -129,4 +133,3 @@
 
 test-clean:
 	$(MAKE) -C tests clean
-

=== debian/changelog ===
mcelog (153+dfsg-1) unstable; urgency=medium

  * New upstream version
    + don't print a struct mce warning on newer kernels (Closes: #852799)
  * Bump Standards-Version to 4.0.0 (no change needed)

 -- Andrey Rahmatullin <wrar@debian.org>  Sun, 09 Jul 2017 21:36:35 +0500

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Andrey Rahmatullin <wrar@debian.org>
 Uploaders: Nicholas D Steeves <nsteeves@gmail.com>
 Build-Depends: debhelper (>= 10), python
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: http://mcelog.org/
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/mcelog.git
 Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/mcelog.git;a=summary
